<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

add_action( 'tgmpa_register', 'airi_register_required_plugins' );


if(!function_exists('lasf_get_plugin_source')){
    function lasf_get_plugin_source( $new, $initial, $plugin_name, $type = 'source'){
        if(isset($new[$plugin_name], $new[$plugin_name][$type]) && version_compare($initial[$plugin_name]['version'], $new[$plugin_name]['version']) < 0 ){
            return $new[$plugin_name][$type];
        }
        else{
            return $initial[$plugin_name][$type];
        }
    }
}

if(!function_exists('airi_register_required_plugins')){

	function airi_register_required_plugins() {

        $initial_required = array(
            'lastudio' => array(
                'source'    => 'https://la-studioweb.com/shared/plugins/airi-lastudio_v2.0.1.zip',
                'version'   => '2.0.1'
            ),
            'airi-demo-data' => array(
                'source'    => 'https://la-studioweb.com/shared/plugins/airi-demo-data_v1.0.2.zip',
                'version'   => '1.0.2'
            ),
            'lastudio-header-builders' => array(
                'source'    => 'https://la-studioweb.com/shared/plugins/lastudio-header-builders_v1.2.4.zip',
                'version'   => '1.2.4'
            ),
            'revslider' => array(
                'source'    => 'https://la-studioweb.com/shared/plugins/revslider_v6.7.11.zip',
                'version'   => '6.7.11'
            ),
            'js_composer' => array(
                'source'    => 'https://la-studioweb.com/shared/plugins/js_composer_v7.6.zip',
                'version'   => '7.6'
            ),
            'lastudio-pagespeed' => array(
                'source'    => 'https://la-studioweb.com/shared/plugins/lastudio-pagespeed_v1.0.8.zip',
                'version'   => '1.0.8'
            )
        );

        $from_option = get_option('airi_required_plugins_list', $initial_required);
	    
		$plugins = array();

		$plugins[] = array(
			'name'					=> esc_html_x('WPBakery Visual Composer', 'admin-view', 'airi'),
			'slug'					=> 'js_composer',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'js_composer'),
            'required'				=> true,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'js_composer', 'version')
		);

		$plugins[] = array(
			'name'					=> esc_html_x('LA-Studio Core', 'admin-view', 'airi'),
			'slug'					=> 'lastudio',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'lastudio'),
            'required'				=> true,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'lastudio', 'version')
		);

		$plugins[] = array(
			'name'					=> esc_html_x('LA-Studio Header Builder', 'admin-view', 'airi'),
			'slug'					=> 'lastudio-header-builders',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'lastudio-header-builders'),
            'required'				=> true,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'lastudio-header-builders', 'version')
		);

		$plugins[] = array(
			'name'     				=> esc_html_x('WooCommerce', 'admin-view', 'airi'),
			'slug'     				=> 'woocommerce',
			'version'				=> '8.9.1',
			'required' 				=> false
		);

		$plugins[] = array(
			'name'     				=> esc_html_x('Envato Market', 'admin-view', 'airi'),
			'slug'     				=> 'envato-market',
			'source'   				=> 'https://envato.github.io/wp-envato-market/dist/envato-market.zip',
			'required' 				=> false,
			'version' 				=> '2.0.11'
		);

		$plugins[] = array(
			'name'					=> esc_html_x('Airi Package Demo Data', 'admin-view', 'airi'),
			'slug'					=> 'airi-demo-data',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'airi-demo-data'),
            'required'				=> true,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'airi-demo-data', 'version')
		);

        $plugins[] = array(
            'name'     				=> esc_html_x('LaStudio PageSpeed', 'admin-view', 'airi'),
            'slug'					=> 'lastudio-pagespeed',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'lastudio-pagespeed'),
            'required'				=> false,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'lastudio-pagespeed', 'version')
        );

		$plugins[] = array(
			'name' 					=> esc_html_x('Contact Form 7', 'admin-view', 'airi'),
			'slug' 					=> 'contact-form-7',
			'required' 				=> false
		);

		$plugins[] = array(
			'name' 					=> esc_html_x('Easy Forms for MailChimp', 'admin-view', 'airi'),
			'slug' 					=> 'yikes-inc-easy-mailchimp-extender',
			'required' 				=> false
		);

		$plugins[] = array(
			'name'					=> esc_html_x('Slider Revolution', 'admin-view', 'airi'),
			'slug'					=> 'revslider',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'revslider'),
            'required'				=> false,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'revslider', 'version')
		);

		$config = array(
			'id'           				=> 'airi',
			'default_path' 				=> '',
			'menu'         				=> 'tgmpa-install-plugins',
			'has_notices'  				=> true,
			'dismissable'  				=> true,
			'dismiss_msg'  				=> '',
			'is_automatic' 				=> false,
			'message'      				=> ''
		);

		tgmpa( $plugins, $config );

	}

}
